searchNodes=[{"type":"module","title":"locus","doc":"The main API","ref":"locus.html"},{"type":"function","title":"locus.await_loader/1","doc":"Like await_loader/1 but with a default timeout of 30 seconds. DatabaseId must be an atom and refer to a database loader. Returns: {ok, LoadedVersion} when the database is ready to use. {error, database_unknown} if the database loader for DatabaseId hasn't been started. {error, {database_stopped, _}} if the database loader for DatabaseId stopped while we waited. {error, {timeout, [_]}} if all the load attempts performed before timing out have failed. See also: await_loader/2 .","ref":"locus.html#await_loader/1"},{"type":"function","title":"locus.await_loader/2","doc":"Blocks caller execution until either readiness is achieved or the default timeout is triggered. DatabaseId must be an atom and refer to a database loader. Timeout must be either a non-negative integer (milliseconds) or infinity . Returns: {ok, LoadedVersion} when the database is ready to use. {error, database_unknown} if the database loader for DatabaseId hasn't been started. {error, {database_stopped, _}} if the database loader for DatabaseId stopped while we waited. {error, {timeout, [_]}} if all the load attempts performed before timing out have failed. See also: await_loader/1 , await_loaders/2 .","ref":"locus.html#await_loader/2"},{"type":"function","title":"locus.await_loaders/2","doc":"Like await_loader/2 but it can concurrently await status from more than one database. DatabaseIds must be list of atom referring to database loaders. Timeout must be either a non-negative integer (milliseconds) or infinity . Returns: {ok, \#{DatabaseId =&gt; LoadedVersion}} when all the database are ready to use. {error, {\#{DatabaseId =&gt; ErrorReason}, _}} in case of errors. See also: await_loader/2 .","ref":"locus.html#await_loaders/2"},{"type":"function","title":"locus.check/1","doc":"Analyzes a loaded database for corruption or incompatibility. DatabaseId must be an atom and refer to a database loader. Returns: ok if the database is wholesome. {error, database_unknown} if the database loader for DatabaseId hasn't been started. {error, database_not_loaded} if the database hasn't yet been loaded. {validation_warnings, [CheckWarning, ...]} in case something smells within the database (check the definitions in locus_mmdb_check ) {validation_errors, [CheckError], [...]} in case of corruption or incompatibility (check the definitions in locus_mmdb_check )","ref":"locus.html#check/1"},{"type":"function","title":"locus.get_info/1","doc":"Returns the properties of a currently loaded database. DatabaseId must be an atom and refer to a database loader. Returns: {ok, database_info()} in case of success {error, database_unknown} if the database loader for DatabaseId hasn't been started. {error, database_not_loaded} if the database hasn't yet been loaded. See also: get_info/2 .","ref":"locus.html#get_info/1"},{"type":"function","title":"locus.get_info/2","doc":"Returns a specific property of a currently loaded database. DatabaseId must be an atom and refer to a database loader. Property must be either metadata , source or version . Returns: {ok, Value} in case of success {error, database_unknown} if the database loader for DatabaseId hasn't been started. {error, database_not_loaded} if the database hasn't yet been loaded. See also: get_info/1 .","ref":"locus.html#get_info/2"},{"type":"function","title":"locus.loader_child_spec/2","doc":"Like :loader_child_spec/2 but with default options DatabaseId must be an atom. LoadFrom must be either: a database_edition() tuple, or a DatabaseURL containing either a string or binary representation of a HTTP(s) URL or local path, or a {custom_fetcher, Module, Args} tuple, with Module implementing the locus_custom_fetcher behaviour Returns: A supervisor:child_spec() . See also: await_loader/1 , await_loader/2 , loader_child_spec/3 , start_loader/2 .","ref":"locus.html#loader_child_spec/2"},{"type":"function","title":"locus.loader_child_spec/3","doc":"Like :loader_child_spec/3 but with default child id DatabaseId must be an atom. LoadFrom must be either: a database_edition() tuple, or a DatabaseURL containing either a string or binary representation of a HTTP(s) URL or local path, or a {custom_fetcher, Module, Args} tuple, with Module implementing the locus_custom_fetcher behaviour Opts must be a list of locus_database:opt() values Returns: A supervisor:child_spec() . See also: await_loader/1 , await_loader/2 , loader_child_spec/2 , loader_child_spec/4 , start_loader/3 .","ref":"locus.html#loader_child_spec/3"},{"type":"function","title":"locus.loader_child_spec/4","doc":"Returns a supervisor child spec for a database loader under id DatabaseId with options Opts . DatabaseId must be an atom. LoadFrom must be either: a database_edition() tuple, or a DatabaseURL containing either a string or binary representation of a HTTP(s) URL or local path, or a {custom_fetcher, Module, Args} tuple, with Module implementing the locus_custom_fetcher behaviour Opts must be a list of locus_database:opt() values Returns: A supervisor:child_spec() . See also: await_loader/1 , await_loader/2 , loader_child_spec/3 , start_loader/3 .","ref":"locus.html#loader_child_spec/4"},{"type":"function","title":"locus.lookup/2","doc":"Looks-up info on IPv4 and IPv6 addresses. DatabaseId must be an atom and refer to a database loader. Address must be either an inet:ip_address() tuple, or a string/binary containing a valid representation of the address. Returns: {ok, Entry} in case of success not_found if no data was found for this Address . {error, invalid_address} if Address is not either a inet:ip_address() tuple or a valid textual representation of an IP address. {error, database_unknown} if the database loader for DatabaseId hasn't been started. {error, database_not_loaded} if the database hasn't yet been loaded. {error, ipv4_database} if Address represents an IPv6 address and the database only supports IPv4 addresses.","ref":"locus.html#lookup/2"},{"type":"function","title":"locus.start_loader/2","doc":"Like :start_loader/3 but with default options DatabaseId must be an atom. LoadFrom must be either: a database_edition() tuple, or a DatabaseURL containing either a string or binary representation of a HTTP(s) URL or local path, or a {custom_fetcher, Module, Args} tuple, with Module implementing the locus_custom_fetcher behaviour Returns: ok in case of success. {error, invalid_url} if the source is invalid. {error, already_started} if the loader under DatabaseId has already been started. See also: await_loader/1 , await_loader/2 , start_loader/3 .","ref":"locus.html#start_loader/2"},{"type":"function","title":"locus.start_loader/3","doc":"Starts a database loader under id DatabaseId with options Opts . DatabaseId must be an atom. LoadFrom must be either: a database_edition() tuple, or a DatabaseURL containing either a string or binary representation of a HTTP(s) URL or local path, or a {custom_fetcher, Module, Args} tuple, with Module implementing the locus_custom_fetcher behaviour Opts must be a list of locus_database:opt() values Returns: ok in case of success. {error, invalid_url} if the source is invalid. {error, already_started} if the loader under DatabaseId has already been started. See also: await_loader/1 , await_loader/2 , start_loader/2 .","ref":"locus.html#start_loader/3"},{"type":"function","title":"locus.stop_loader/1","doc":"Stops the database loader under id DatabaseId . DatabaseId must be an atom and refer to a database loader. Returns ok in case of success, {error, not_found} otherwise.","ref":"locus.html#stop_loader/1"},{"type":"type","title":"locus.custom_fetcher/0","doc":"","ref":"locus.html#t:custom_fetcher/0"},{"type":"type","title":"locus.database_edition/0","doc":"","ref":"locus.html#t:database_edition/0"},{"type":"type","title":"locus.database_entry/0","doc":"","ref":"locus.html#t:database_entry/0"},{"type":"type","title":"locus.database_error/0","doc":"","ref":"locus.html#t:database_error/0"},{"type":"type","title":"locus.database_info/0","doc":"","ref":"locus.html#t:database_info/0"},{"type":"type","title":"locus.database_metadata/0","doc":"","ref":"locus.html#t:database_metadata/0"},{"type":"type","title":"locus.database_source/0","doc":"","ref":"locus.html#t:database_source/0"},{"type":"type","title":"locus.database_url/0","doc":"","ref":"locus.html#t:database_url/0"},{"type":"type","title":"locus.database_version/0","doc":"","ref":"locus.html#t:database_version/0"},{"type":"type","title":"locus.ip_address_prefix/0","doc":"","ref":"locus.html#t:ip_address_prefix/0"},{"type":"type","title":"locus.legacy_maxmind_database_edition/0","doc":"","ref":"locus.html#t:legacy_maxmind_database_edition/0"},{"type":"type","title":"locus.maxmind_database_edition/0","doc":"","ref":"locus.html#t:maxmind_database_edition/0"},{"type":"module","title":"locus_app","doc":"","ref":"locus_app.html"},{"type":"function","title":"locus_app.start/2","doc":"","ref":"locus_app.html#start/2"},{"type":"function","title":"locus_app.stop/1","doc":"","ref":"locus_app.html#stop/1"},{"type":"module","title":"locus_cli","doc":"","ref":"locus_cli.html"},{"type":"behaviour","title":"locus_custom_fetcher","doc":"Callbacks for providing your own database fetcher","ref":"locus_custom_fetcher.html"},{"type":"function","title":"locus_custom_fetcher.code_change/3","doc":"","ref":"locus_custom_fetcher.html#code_change/3"},{"type":"callback","title":"locus_custom_fetcher.conditionally_fetch/2","doc":"","ref":"locus_custom_fetcher.html#c:conditionally_fetch/2"},{"type":"callback","title":"locus_custom_fetcher.description/1","doc":"","ref":"locus_custom_fetcher.html#c:description/1"},{"type":"function","title":"locus_custom_fetcher.description/2","doc":"","ref":"locus_custom_fetcher.html#description/2"},{"type":"callback","title":"locus_custom_fetcher.fetch/1","doc":"","ref":"locus_custom_fetcher.html#c:fetch/1"},{"type":"function","title":"locus_custom_fetcher.handle_call/3","doc":"","ref":"locus_custom_fetcher.html#handle_call/3"},{"type":"function","title":"locus_custom_fetcher.handle_cast/2","doc":"","ref":"locus_custom_fetcher.html#handle_cast/2"},{"type":"function","title":"locus_custom_fetcher.handle_continue/2","doc":"","ref":"locus_custom_fetcher.html#handle_continue/2"},{"type":"function","title":"locus_custom_fetcher.handle_info/2","doc":"","ref":"locus_custom_fetcher.html#handle_info/2"},{"type":"function","title":"locus_custom_fetcher.init/1","doc":"","ref":"locus_custom_fetcher.html#init/1"},{"type":"function","title":"locus_custom_fetcher.source/2","doc":"","ref":"locus_custom_fetcher.html#source/2"},{"type":"function","title":"locus_custom_fetcher.start_link/4","doc":"","ref":"locus_custom_fetcher.html#start_link/4"},{"type":"function","title":"locus_custom_fetcher.terminate/2","doc":"","ref":"locus_custom_fetcher.html#terminate/2"},{"type":"type","title":"locus_custom_fetcher.description/0","doc":"","ref":"locus_custom_fetcher.html#t:description/0"},{"type":"type","title":"locus_custom_fetcher.event/0","doc":"","ref":"locus_custom_fetcher.html#t:event/0"},{"type":"type","title":"locus_custom_fetcher.event_load_attempt_dismissed/0","doc":"","ref":"locus_custom_fetcher.html#t:event_load_attempt_dismissed/0"},{"type":"type","title":"locus_custom_fetcher.event_load_attempt_started/0","doc":"","ref":"locus_custom_fetcher.html#t:event_load_attempt_started/0"},{"type":"type","title":"locus_custom_fetcher.msg/0","doc":"","ref":"locus_custom_fetcher.html#t:msg/0"},{"type":"type","title":"locus_custom_fetcher.source/0","doc":"","ref":"locus_custom_fetcher.html#t:source/0"},{"type":"type","title":"locus_custom_fetcher.state/0","doc":"","ref":"locus_custom_fetcher.html#t:state/0"},{"type":"type","title":"locus_custom_fetcher.success/0","doc":"","ref":"locus_custom_fetcher.html#t:success/0"},{"type":"type","title":"locus_custom_fetcher.successful_fetch_metadata/0","doc":"","ref":"locus_custom_fetcher.html#t:successful_fetch_metadata/0"},{"type":"module","title":"locus_database","doc":"Launches locus_database_loader and later shares the unpacked database, as well as any updates to it, through persistent_term .","ref":"locus_database.html"},{"type":"function","title":"locus_database.async_get_version_or_subscribe/1","doc":"","ref":"locus_database.html#async_get_version_or_subscribe/1"},{"type":"function","title":"locus_database.code_change/3","doc":"","ref":"locus_database.html#code_change/3"},{"type":"function","title":"locus_database.dynamic_child_spec/1","doc":"","ref":"locus_database.html#dynamic_child_spec/1"},{"type":"function","title":"locus_database.find/1","doc":"","ref":"locus_database.html#find/1"},{"type":"function","title":"locus_database.handle_call/3","doc":"","ref":"locus_database.html#handle_call/3"},{"type":"function","title":"locus_database.handle_cast/2","doc":"","ref":"locus_database.html#handle_cast/2"},{"type":"function","title":"locus_database.handle_info/2","doc":"","ref":"locus_database.html#handle_info/2"},{"type":"function","title":"locus_database.init/1","doc":"","ref":"locus_database.html#init/1"},{"type":"function","title":"locus_database.start/3","doc":"","ref":"locus_database.html#start/3"},{"type":"function","title":"locus_database.start_link/3","doc":"","ref":"locus_database.html#start_link/3"},{"type":"function","title":"locus_database.static_child_spec/4","doc":"","ref":"locus_database.html#static_child_spec/4"},{"type":"function","title":"locus_database.stop/2","doc":"","ref":"locus_database.html#stop/2"},{"type":"function","title":"locus_database.terminate/2","doc":"","ref":"locus_database.html#terminate/2"},{"type":"function","title":"locus_database.version/1","doc":"Returns the database version based on its build epoch (UNIX timestamp)","ref":"locus_database.html#version/1"},{"type":"type","title":"locus_database.database_opt/0","doc":"","ref":"locus_database.html#t:database_opt/0"},{"type":"type","title":"locus_database.event/0","doc":"","ref":"locus_database.html#t:event/0"},{"type":"type","title":"locus_database.event_load_attempt_finished/0","doc":"","ref":"locus_database.html#t:event_load_attempt_finished/0"},{"type":"type","title":"locus_database.monitor/0","doc":"","ref":"locus_database.html#t:monitor/0"},{"type":"type","title":"locus_database.opt/0","doc":"","ref":"locus_database.html#t:opt/0"},{"type":"type","title":"locus_database.origin/0","doc":"","ref":"locus_database.html#t:origin/0"},{"type":"type","title":"locus_database.state/0","doc":"","ref":"locus_database.html#t:state/0"},{"type":"type","title":"locus_database.static_child_spec/0","doc":"","ref":"locus_database.html#t:static_child_spec/0"},{"type":"module","title":"locus_database_sup","doc":"","ref":"locus_database_sup.html"},{"type":"function","title":"locus_database_sup.init/1","doc":"","ref":"locus_database_sup.html#init/1"},{"type":"function","title":"locus_database_sup.start_child/1","doc":"","ref":"locus_database_sup.html#start_child/1"},{"type":"function","title":"locus_database_sup.start_link/0","doc":"","ref":"locus_database_sup.html#start_link/0"},{"type":"behaviour","title":"locus_event_subscriber","doc":"Callback for implementing your own locus_database event subscribers","ref":"locus_event_subscriber.html"},{"type":"callback","title":"locus_event_subscriber.report/2","doc":"","ref":"locus_event_subscriber.html#c:report/2"},{"type":"function","title":"locus_event_subscriber.report/3","doc":"","ref":"locus_event_subscriber.html#report/3"},{"type":"type","title":"locus_event_subscriber.event/0","doc":"","ref":"locus_event_subscriber.html#t:event/0"},{"type":"module","title":"locus_filesystem_load","doc":"Loads a file from the filesystem without blocking the caller","ref":"locus_filesystem_load.html"},{"type":"function","title":"locus_filesystem_load.code_change/3","doc":"","ref":"locus_filesystem_load.html#code_change/3"},{"type":"function","title":"locus_filesystem_load.handle_call/3","doc":"","ref":"locus_filesystem_load.html#handle_call/3"},{"type":"function","title":"locus_filesystem_load.handle_cast/2","doc":"","ref":"locus_filesystem_load.html#handle_cast/2"},{"type":"function","title":"locus_filesystem_load.handle_info/2","doc":"","ref":"locus_filesystem_load.html#handle_info/2"},{"type":"function","title":"locus_filesystem_load.init/1","doc":"","ref":"locus_filesystem_load.html#init/1"},{"type":"function","title":"locus_filesystem_load.start_link/2","doc":"","ref":"locus_filesystem_load.html#start_link/2"},{"type":"function","title":"locus_filesystem_load.terminate/2","doc":"","ref":"locus_filesystem_load.html#terminate/2"},{"type":"type","title":"locus_filesystem_load.event/0","doc":"","ref":"locus_filesystem_load.html#t:event/0"},{"type":"type","title":"locus_filesystem_load.event_load_attempt_dismissed/0","doc":"","ref":"locus_filesystem_load.html#t:event_load_attempt_dismissed/0"},{"type":"type","title":"locus_filesystem_load.event_load_attempt_started/0","doc":"","ref":"locus_filesystem_load.html#t:event_load_attempt_started/0"},{"type":"type","title":"locus_filesystem_load.msg/0","doc":"","ref":"locus_filesystem_load.html#t:msg/0"},{"type":"type","title":"locus_filesystem_load.path/0","doc":"","ref":"locus_filesystem_load.html#t:path/0"},{"type":"type","title":"locus_filesystem_load.source/0","doc":"","ref":"locus_filesystem_load.html#t:source/0"},{"type":"type","title":"locus_filesystem_load.state/0","doc":"","ref":"locus_filesystem_load.html#t:state/0"},{"type":"type","title":"locus_filesystem_load.success/0","doc":"","ref":"locus_filesystem_load.html#t:success/0"},{"type":"module","title":"locus_filesystem_store","doc":"Stores a file in the filesystem without blocking the caller","ref":"locus_filesystem_store.html"},{"type":"function","title":"locus_filesystem_store.code_change/3","doc":"","ref":"locus_filesystem_store.html#code_change/3"},{"type":"function","title":"locus_filesystem_store.handle_call/3","doc":"","ref":"locus_filesystem_store.html#handle_call/3"},{"type":"function","title":"locus_filesystem_store.handle_cast/2","doc":"","ref":"locus_filesystem_store.html#handle_cast/2"},{"type":"function","title":"locus_filesystem_store.handle_info/2","doc":"","ref":"locus_filesystem_store.html#handle_info/2"},{"type":"function","title":"locus_filesystem_store.init/1","doc":"","ref":"locus_filesystem_store.html#init/1"},{"type":"function","title":"locus_filesystem_store.start_link/3","doc":"","ref":"locus_filesystem_store.html#start_link/3"},{"type":"function","title":"locus_filesystem_store.terminate/2","doc":"","ref":"locus_filesystem_store.html#terminate/2"},{"type":"type","title":"locus_filesystem_store.msg/0","doc":"","ref":"locus_filesystem_store.html#t:msg/0"},{"type":"type","title":"locus_filesystem_store.path/0","doc":"","ref":"locus_filesystem_store.html#t:path/0"},{"type":"type","title":"locus_filesystem_store.state/0","doc":"","ref":"locus_filesystem_store.html#t:state/0"},{"type":"module","title":"locus_http_download","doc":"Downloads a file using HTTP(S) without blocking the caller","ref":"locus_http_download.html"},{"type":"function","title":"locus_http_download.code_change/3","doc":"","ref":"locus_http_download.html#code_change/3"},{"type":"function","title":"locus_http_download.handle_call/3","doc":"","ref":"locus_http_download.html#handle_call/3"},{"type":"function","title":"locus_http_download.handle_cast/2","doc":"","ref":"locus_http_download.html#handle_cast/2"},{"type":"function","title":"locus_http_download.handle_info/2","doc":"","ref":"locus_http_download.html#handle_info/2"},{"type":"function","title":"locus_http_download.init/1","doc":"","ref":"locus_http_download.html#init/1"},{"type":"function","title":"locus_http_download.start_link/3","doc":"","ref":"locus_http_download.html#start_link/3"},{"type":"function","title":"locus_http_download.terminate/2","doc":"","ref":"locus_http_download.html#terminate/2"},{"type":"function","title":"locus_http_download.validate_opts/1","doc":"","ref":"locus_http_download.html#validate_opts/1"},{"type":"type","title":"locus_http_download.body/0","doc":"","ref":"locus_http_download.html#t:body/0"},{"type":"type","title":"locus_http_download.event/0","doc":"","ref":"locus_http_download.html#t:event/0"},{"type":"type","title":"locus_http_download.event_download_dismissed/0","doc":"","ref":"locus_http_download.html#t:event_download_dismissed/0"},{"type":"type","title":"locus_http_download.event_download_failed_to_start/0","doc":"","ref":"locus_http_download.html#t:event_download_failed_to_start/0"},{"type":"type","title":"locus_http_download.event_download_finished/0","doc":"","ref":"locus_http_download.html#t:event_download_finished/0"},{"type":"type","title":"locus_http_download.event_download_redirected/0","doc":"","ref":"locus_http_download.html#t:event_download_redirected/0"},{"type":"type","title":"locus_http_download.event_download_started/0","doc":"","ref":"locus_http_download.html#t:event_download_started/0"},{"type":"type","title":"locus_http_download.event_request_sent/0","doc":"","ref":"locus_http_download.html#t:event_request_sent/0"},{"type":"type","title":"locus_http_download.full_http_response/0","doc":"","ref":"locus_http_download.html#t:full_http_response/0"},{"type":"type","title":"locus_http_download.headers/0","doc":"","ref":"locus_http_download.html#t:headers/0"},{"type":"type","title":"locus_http_download.msg/0","doc":"","ref":"locus_http_download.html#t:msg/0"},{"type":"type","title":"locus_http_download.opt/0","doc":"","ref":"locus_http_download.html#t:opt/0"},{"type":"type","title":"locus_http_download.reason_for_download_failing_to_start/0","doc":"","ref":"locus_http_download.html#t:reason_for_download_failing_to_start/0"},{"type":"type","title":"locus_http_download.redirection/0","doc":"","ref":"locus_http_download.html#t:redirection/0"},{"type":"type","title":"locus_http_download.response_status/0","doc":"","ref":"locus_http_download.html#t:response_status/0"},{"type":"type","title":"locus_http_download.state/0","doc":"","ref":"locus_http_download.html#t:state/0"},{"type":"type","title":"locus_http_download.success/0","doc":"","ref":"locus_http_download.html#t:success/0"},{"type":"type","title":"locus_http_download.url/0","doc":"","ref":"locus_http_download.html#t:url/0"},{"type":"module","title":"locus_loader","doc":"Loads and unpacks databases while managing any associated assets (e.g. reading from and writing to cache)","ref":"locus_loader.html"},{"type":"function","title":"locus_loader.code_change/3","doc":"","ref":"locus_loader.html#code_change/3"},{"type":"function","title":"locus_loader.handle_call/3","doc":"","ref":"locus_loader.html#handle_call/3"},{"type":"function","title":"locus_loader.handle_cast/2","doc":"","ref":"locus_loader.html#handle_cast/2"},{"type":"function","title":"locus_loader.handle_info/2","doc":"","ref":"locus_loader.html#handle_info/2"},{"type":"function","title":"locus_loader.init/1","doc":"","ref":"locus_loader.html#init/1"},{"type":"function","title":"locus_loader.start_link/4","doc":"","ref":"locus_loader.html#start_link/4"},{"type":"function","title":"locus_loader.terminate/2","doc":"","ref":"locus_loader.html#terminate/2"},{"type":"function","title":"locus_loader.valid_blob_formats/0","doc":"","ref":"locus_loader.html#valid_blob_formats/0"},{"type":"function","title":"locus_loader.validate_opts/2","doc":"","ref":"locus_loader.html#validate_opts/2"},{"type":"type","title":"locus_loader.blob_format/0","doc":"","ref":"locus_loader.html#t:blob_format/0"},{"type":"type","title":"locus_loader.cacher_msg/0","doc":"","ref":"locus_loader.html#t:cacher_msg/0"},{"type":"type","title":"locus_loader.error_retry_behaviour/0","doc":"","ref":"locus_loader.html#t:error_retry_behaviour/0"},{"type":"type","title":"locus_loader.event/0","doc":"","ref":"locus_loader.html#t:event/0"},{"type":"type","title":"locus_loader.event_cache_attempt_finished/0","doc":"","ref":"locus_loader.html#t:event_cache_attempt_finished/0"},{"type":"type","title":"locus_loader.exponential_backoff_params/0","doc":"","ref":"locus_loader.html#t:exponential_backoff_params/0"},{"type":"type","title":"locus_loader.fetcher_msg/0","doc":"","ref":"locus_loader.html#t:fetcher_msg/0"},{"type":"type","title":"locus_loader.fetcher_opt/0","doc":"","ref":"locus_loader.html#t:fetcher_opt/0"},{"type":"type","title":"locus_loader.fetcher_success/0","doc":"","ref":"locus_loader.html#t:fetcher_success/0"},{"type":"type","title":"locus_loader.loader_opt/0","doc":"","ref":"locus_loader.html#t:loader_opt/0"},{"type":"type","title":"locus_loader.maxmind_origin_params/0","doc":"","ref":"locus_loader.html#t:maxmind_origin_params/0"},{"type":"type","title":"locus_loader.milliseconds_interval/0","doc":"","ref":"locus_loader.html#t:milliseconds_interval/0"},{"type":"type","title":"locus_loader.msg/0","doc":"","ref":"locus_loader.html#t:msg/0"},{"type":"type","title":"locus_loader.opt/0","doc":"","ref":"locus_loader.html#t:opt/0"},{"type":"type","title":"locus_loader.origin/0","doc":"","ref":"locus_loader.html#t:origin/0"},{"type":"type","title":"locus_loader.provider_source/0","doc":"","ref":"locus_loader.html#t:provider_source/0"},{"type":"type","title":"locus_loader.settings/0","doc":"","ref":"locus_loader.html#t:settings/0"},{"type":"type","title":"locus_loader.source/0","doc":"","ref":"locus_loader.html#t:source/0"},{"type":"type","title":"locus_loader.state/0","doc":"","ref":"locus_loader.html#t:state/0"},{"type":"type","title":"locus_loader.uniformly_distributed_update_period/0","doc":"","ref":"locus_loader.html#t:uniformly_distributed_update_period/0"},{"type":"type","title":"locus_loader.update_period/0","doc":"","ref":"locus_loader.html#t:update_period/0"},{"type":"module","title":"locus_logger","doc":"Logging of locus_database events; can be adjusted in app config as well as at run time.","ref":"locus_logger.html"},{"type":"function","title":"locus_logger.on_app_start/0","doc":"","ref":"locus_logger.html#on_app_start/0"},{"type":"function","title":"locus_logger.report/2","doc":"","ref":"locus_logger.html#report/2"},{"type":"function","title":"locus_logger.set_loglevel/1","doc":"Changes the logging verbosity in runtime Level must be either debug , info , warning , error or none .","ref":"locus_logger.html#set_loglevel/1"},{"type":"module","title":"locus_maxmind_download","doc":"Downloads an unpacked database edition from MaxMind, as well as its checksum (which it then verifies), without blocking the caller.","ref":"locus_maxmind_download.html"},{"type":"function","title":"locus_maxmind_download.code_change/3","doc":"","ref":"locus_maxmind_download.html#code_change/3"},{"type":"function","title":"locus_maxmind_download.handle_call/3","doc":"","ref":"locus_maxmind_download.html#handle_call/3"},{"type":"function","title":"locus_maxmind_download.handle_cast/2","doc":"","ref":"locus_maxmind_download.html#handle_cast/2"},{"type":"function","title":"locus_maxmind_download.handle_info/2","doc":"","ref":"locus_maxmind_download.html#handle_info/2"},{"type":"function","title":"locus_maxmind_download.init/1","doc":"","ref":"locus_maxmind_download.html#init/1"},{"type":"function","title":"locus_maxmind_download.init_/1","doc":"","ref":"locus_maxmind_download.html#init_/1"},{"type":"function","title":"locus_maxmind_download.start_link/3","doc":"","ref":"locus_maxmind_download.html#start_link/3"},{"type":"function","title":"locus_maxmind_download.terminate/2","doc":"","ref":"locus_maxmind_download.html#terminate/2"},{"type":"function","title":"locus_maxmind_download.validate_opts/1","doc":"","ref":"locus_maxmind_download.html#validate_opts/1"},{"type":"type","title":"locus_maxmind_download.event/0","doc":"","ref":"locus_maxmind_download.html#t:event/0"},{"type":"type","title":"locus_maxmind_download.msg/0","doc":"","ref":"locus_maxmind_download.html#t:msg/0"},{"type":"type","title":"locus_maxmind_download.opt/0","doc":"","ref":"locus_maxmind_download.html#t:opt/0"},{"type":"type","title":"locus_maxmind_download.state/0","doc":"","ref":"locus_maxmind_download.html#t:state/0"},{"type":"type","title":"locus_maxmind_download.success/0","doc":"","ref":"locus_maxmind_download.html#t:success/0"},{"type":"module","title":"locus_mmdb","doc":"API for working with MMDB","ref":"locus_mmdb.html"},{"type":"function","title":"locus_mmdb.lookup_address/2","doc":"Looks up for an entry matching Address within Database","ref":"locus_mmdb.html#lookup_address/2"},{"type":"function","title":"locus_mmdb.parse_all_data_section_values/1","doc":"","ref":"locus_mmdb.html#parse_all_data_section_values/1"},{"type":"function","title":"locus_mmdb.parse_data_section_value/2","doc":"","ref":"locus_mmdb.html#parse_data_section_value/2"},{"type":"function","title":"locus_mmdb.unpack_database/1","doc":"Unpacks an EncodedDatabase binary into a ready-to-use Database .","ref":"locus_mmdb.html#unpack_database/1"},{"type":"function","title":"locus_mmdb.unpack_tree_data_and_data_section/2","doc":"Unpacks a single TreeAndDataSection binary into separate TreeData and DataSection binaries, leveraging Metadata to calculate the size of TreeData . You can then use TreeData on your own or leverage it to instantiate a new locus_mmdb_tree:t() , through locus_mmdb_tree:new/5 . As for DataSection , you can also either use it on your own or pass it to the API defined under locus_mmdb_data_codec . For how to obtain Metadata and TreeAndDataSection in the first place, see locus_mmdb_metadata:parse_and_validate/1 .","ref":"locus_mmdb.html#unpack_tree_data_and_data_section/2"},{"type":"type","title":"locus_mmdb.database/0","doc":"","ref":"locus_mmdb.html#t:database/0"},{"type":"type","title":"locus_mmdb.failed_to_unpack_tree_data_and_data_section/0","doc":"","ref":"locus_mmdb.html#t:failed_to_unpack_tree_data_and_data_section/0"},{"type":"type","title":"locus_mmdb.unpack_error/0","doc":"","ref":"locus_mmdb.html#t:unpack_error/0"},{"type":"module","title":"locus_mmdb_check","doc":"API for working with MMDB - wholesomeness check","ref":"locus_mmdb_check.html"},{"type":"function","title":"locus_mmdb_check.run/1","doc":"Checks for errors and quirks within Database","ref":"locus_mmdb_check.html#run/1"},{"type":"type","title":"locus_mmdb_check.bad_chunk_in_data_section/0","doc":"","ref":"locus_mmdb_check.html#t:bad_chunk_in_data_section/0"},{"type":"type","title":"locus_mmdb_check.bad_data_index_in_tree/0","doc":"","ref":"locus_mmdb_check.html#t:bad_data_index_in_tree/0"},{"type":"type","title":"locus_mmdb_check.bad_node_index_in_tree/0","doc":"","ref":"locus_mmdb_check.html#t:bad_node_index_in_tree/0"},{"type":"type","title":"locus_mmdb_check.error/0","doc":"","ref":"locus_mmdb_check.html#t:error/0"},{"type":"type","title":"locus_mmdb_check.excessively_long_path_in_tree/0","doc":"","ref":"locus_mmdb_check.html#t:excessively_long_path_in_tree/0"},{"type":"type","title":"locus_mmdb_check.invalid_position_in_data_section/0","doc":"","ref":"locus_mmdb_check.html#t:invalid_position_in_data_section/0"},{"type":"type","title":"locus_mmdb_check.invalid_utf8_string_in_data_section/0","doc":"","ref":"locus_mmdb_check.html#t:invalid_utf8_string_in_data_section/0"},{"type":"type","title":"locus_mmdb_check.loop_in_data_section/0","doc":"","ref":"locus_mmdb_check.html#t:loop_in_data_section/0"},{"type":"type","title":"locus_mmdb_check.map_key_of_wrong_type_in_data_section/0","doc":"","ref":"locus_mmdb_check.html#t:map_key_of_wrong_type_in_data_section/0"},{"type":"type","title":"locus_mmdb_check.unprintable_utf8_string_in_data_section/0","doc":"","ref":"locus_mmdb_check.html#t:unprintable_utf8_string_in_data_section/0"},{"type":"type","title":"locus_mmdb_check.warning/0","doc":"","ref":"locus_mmdb_check.html#t:warning/0"},{"type":"module","title":"locus_mmdb_check_journal","doc":"","ref":"locus_mmdb_check_journal.html"},{"type":"function","title":"locus_mmdb_check_journal.bad_chunk_in_data_section/4","doc":"","ref":"locus_mmdb_check_journal.html#bad_chunk_in_data_section/4"},{"type":"function","title":"locus_mmdb_check_journal.bad_data_index_in_tree/5","doc":"","ref":"locus_mmdb_check_journal.html#bad_data_index_in_tree/5"},{"type":"function","title":"locus_mmdb_check_journal.bad_node_index_in_tree/4","doc":"","ref":"locus_mmdb_check_journal.html#bad_node_index_in_tree/4"},{"type":"function","title":"locus_mmdb_check_journal.check/1","doc":"","ref":"locus_mmdb_check_journal.html#check/1"},{"type":"function","title":"locus_mmdb_check_journal.delete/1","doc":"","ref":"locus_mmdb_check_journal.html#delete/1"},{"type":"function","title":"locus_mmdb_check_journal.excessively_long_path_in_tree/4","doc":"","ref":"locus_mmdb_check_journal.html#excessively_long_path_in_tree/4"},{"type":"function","title":"locus_mmdb_check_journal.invalid_position_in_data_section/3","doc":"","ref":"locus_mmdb_check_journal.html#invalid_position_in_data_section/3"},{"type":"function","title":"locus_mmdb_check_journal.invalid_utf8_string_in_data_section/5","doc":"","ref":"locus_mmdb_check_journal.html#invalid_utf8_string_in_data_section/5"},{"type":"function","title":"locus_mmdb_check_journal.loop_in_data_section/2","doc":"","ref":"locus_mmdb_check_journal.html#loop_in_data_section/2"},{"type":"function","title":"locus_mmdb_check_journal.map_key_of_wrong_type_in_data_section/4","doc":"","ref":"locus_mmdb_check_journal.html#map_key_of_wrong_type_in_data_section/4"},{"type":"function","title":"locus_mmdb_check_journal.new/0","doc":"","ref":"locus_mmdb_check_journal.html#new/0"},{"type":"function","title":"locus_mmdb_check_journal.unprintable_utf8_string_in_data_section/4","doc":"","ref":"locus_mmdb_check_journal.html#unprintable_utf8_string_in_data_section/4"},{"type":"opaque","title":"locus_mmdb_check_journal.t/0","doc":"","ref":"locus_mmdb_check_journal.html#t:t/0"},{"type":"module","title":"locus_mmdb_data","doc":"API for working with MMDB - data representation","ref":"locus_mmdb_data.html"},{"type":"type","title":"locus_mmdb_data.array/0","doc":"","ref":"locus_mmdb_data.html#t:array/0"},{"type":"type","title":"locus_mmdb_data.boolean_/0","doc":"","ref":"locus_mmdb_data.html#t:boolean_/0"},{"type":"type","title":"locus_mmdb_data.bytes/0","doc":"","ref":"locus_mmdb_data.html#t:bytes/0"},{"type":"type","title":"locus_mmdb_data.double/0","doc":"","ref":"locus_mmdb_data.html#t:double/0"},{"type":"type","title":"locus_mmdb_data.float_/0","doc":"","ref":"locus_mmdb_data.html#t:float_/0"},{"type":"type","title":"locus_mmdb_data.int32/0","doc":"","ref":"locus_mmdb_data.html#t:int32/0"},{"type":"type","title":"locus_mmdb_data.map_/0","doc":"","ref":"locus_mmdb_data.html#t:map_/0"},{"type":"type","title":"locus_mmdb_data.uint128/0","doc":"","ref":"locus_mmdb_data.html#t:uint128/0"},{"type":"type","title":"locus_mmdb_data.uint16/0","doc":"","ref":"locus_mmdb_data.html#t:uint16/0"},{"type":"type","title":"locus_mmdb_data.uint32/0","doc":"","ref":"locus_mmdb_data.html#t:uint32/0"},{"type":"type","title":"locus_mmdb_data.uint64/0","doc":"","ref":"locus_mmdb_data.html#t:uint64/0"},{"type":"type","title":"locus_mmdb_data.utf8_string/0","doc":"","ref":"locus_mmdb_data.html#t:utf8_string/0"},{"type":"type","title":"locus_mmdb_data.value/0","doc":"","ref":"locus_mmdb_data.html#t:value/0"},{"type":"module","title":"locus_mmdb_data_codec","doc":"API for working with MMDB - data codec","ref":"locus_mmdb_data_codec.html"},{"type":"function","title":"locus_mmdb_data_codec.parse_all/2","doc":"","ref":"locus_mmdb_data_codec.html#parse_all/2"},{"type":"function","title":"locus_mmdb_data_codec.parse_on_index/3","doc":"Attempts to parse either the Value or RawValue (depending on the Raw flag) at Index in DataSection . Will crash upon invalid/unrecognized data, invalid pointers or cyclic pointer chasing (i.e. loops.)","ref":"locus_mmdb_data_codec.html#parse_on_index/3"},{"type":"function","title":"locus_mmdb_data_codec.validate_indices_in_tree/7","doc":"","ref":"locus_mmdb_data_codec.html#validate_indices_in_tree/7"},{"type":"type","title":"locus_mmdb_data_codec.index/0","doc":"","ref":"locus_mmdb_data_codec.html#t:index/0"},{"type":"module","title":"locus_mmdb_data_raw","doc":"API for working with MMDB - raw data representation (it preserves the original type for when it's necessary to distinguish between e.g. {uint32, 0} and {uint16, 0} , which locus_mmdb_data does not allow for.)","ref":"locus_mmdb_data_raw.html"},{"type":"type","title":"locus_mmdb_data_raw.array/0","doc":"","ref":"locus_mmdb_data_raw.html#t:array/0"},{"type":"type","title":"locus_mmdb_data_raw.boolean_/0","doc":"","ref":"locus_mmdb_data_raw.html#t:boolean_/0"},{"type":"type","title":"locus_mmdb_data_raw.bytes/0","doc":"","ref":"locus_mmdb_data_raw.html#t:bytes/0"},{"type":"type","title":"locus_mmdb_data_raw.double/0","doc":"","ref":"locus_mmdb_data_raw.html#t:double/0"},{"type":"type","title":"locus_mmdb_data_raw.float_/0","doc":"","ref":"locus_mmdb_data_raw.html#t:float_/0"},{"type":"type","title":"locus_mmdb_data_raw.int32/0","doc":"","ref":"locus_mmdb_data_raw.html#t:int32/0"},{"type":"type","title":"locus_mmdb_data_raw.map_/0","doc":"","ref":"locus_mmdb_data_raw.html#t:map_/0"},{"type":"type","title":"locus_mmdb_data_raw.uint128/0","doc":"","ref":"locus_mmdb_data_raw.html#t:uint128/0"},{"type":"type","title":"locus_mmdb_data_raw.uint16/0","doc":"","ref":"locus_mmdb_data_raw.html#t:uint16/0"},{"type":"type","title":"locus_mmdb_data_raw.uint32/0","doc":"","ref":"locus_mmdb_data_raw.html#t:uint32/0"},{"type":"type","title":"locus_mmdb_data_raw.uint64/0","doc":"","ref":"locus_mmdb_data_raw.html#t:uint64/0"},{"type":"type","title":"locus_mmdb_data_raw.utf8_string/0","doc":"","ref":"locus_mmdb_data_raw.html#t:utf8_string/0"},{"type":"type","title":"locus_mmdb_data_raw.value/0","doc":"","ref":"locus_mmdb_data_raw.html#t:value/0"},{"type":"type","title":"locus_mmdb_data_raw.value_tag/0","doc":"","ref":"locus_mmdb_data_raw.html#t:value_tag/0"},{"type":"module","title":"locus_mmdb_metadata","doc":"API for working with MMDB - metadata","ref":"locus_mmdb_metadata.html"},{"type":"function","title":"locus_mmdb_metadata.parse_and_validate/1","doc":"Parses and validates Metadata out of EncodedDatabase To proceed further with TreeAndDataSection , see locus_mmdb:unpack_tree_data_and_data_section/2 .","ref":"locus_mmdb_metadata.html#parse_and_validate/1"},{"type":"type","title":"locus_mmdb_metadata.binary_format_version/0","doc":"{Major, Minor}","ref":"locus_mmdb_metadata.html#t:binary_format_version/0"},{"type":"type","title":"locus_mmdb_metadata.parse_or_validation_error/0","doc":"","ref":"locus_mmdb_metadata.html#t:parse_or_validation_error/0"},{"type":"type","title":"locus_mmdb_metadata.t/0","doc":"","ref":"locus_mmdb_metadata.html#t:t/0"},{"type":"module","title":"locus_mmdb_tree","doc":"API for working with MMDB - tree section","ref":"locus_mmdb_tree.html"},{"type":"function","title":"locus_mmdb_tree.lookup/2","doc":"Looks up for a DataIndex for Address within Tree","ref":"locus_mmdb_tree.html#lookup/2"},{"type":"function","title":"locus_mmdb_tree.new/5","doc":"Instantiates a new Tree out of TreeData , a few metadata properties and DataSectionSize","ref":"locus_mmdb_tree.html#new/5"},{"type":"function","title":"locus_mmdb_tree.validate/4","doc":"","ref":"locus_mmdb_tree.html#validate/4"},{"type":"type","title":"locus_mmdb_tree.bad_tree_error/0","doc":"","ref":"locus_mmdb_tree.html#t:bad_tree_error/0"},{"type":"type","title":"locus_mmdb_tree.index/0","doc":"","ref":"locus_mmdb_tree.html#t:index/0"},{"type":"type","title":"locus_mmdb_tree.ip4_address_prefix/0","doc":"","ref":"locus_mmdb_tree.html#t:ip4_address_prefix/0"},{"type":"type","title":"locus_mmdb_tree.ip6_address_prefix/0","doc":"","ref":"locus_mmdb_tree.html#t:ip6_address_prefix/0"},{"type":"type","title":"locus_mmdb_tree.ip_address_prefix/0","doc":"","ref":"locus_mmdb_tree.html#t:ip_address_prefix/0"},{"type":"opaque","title":"locus_mmdb_tree.t/0","doc":"","ref":"locus_mmdb_tree.html#t:t/0"},{"type":"module","title":"locus_mmdb_tree_walk_manager","doc":"","ref":"locus_mmdb_tree_walk_manager.html"},{"type":"function","title":"locus_mmdb_tree_walk_manager.code_change/3","doc":"","ref":"locus_mmdb_tree_walk_manager.html#code_change/3"},{"type":"function","title":"locus_mmdb_tree_walk_manager.handle_call/3","doc":"","ref":"locus_mmdb_tree_walk_manager.html#handle_call/3"},{"type":"function","title":"locus_mmdb_tree_walk_manager.handle_cast/2","doc":"","ref":"locus_mmdb_tree_walk_manager.html#handle_cast/2"},{"type":"function","title":"locus_mmdb_tree_walk_manager.handle_info/2","doc":"","ref":"locus_mmdb_tree_walk_manager.html#handle_info/2"},{"type":"function","title":"locus_mmdb_tree_walk_manager.init/1","doc":"","ref":"locus_mmdb_tree_walk_manager.html#init/1"},{"type":"function","title":"locus_mmdb_tree_walk_manager.maybe_give_index/3","doc":"","ref":"locus_mmdb_tree_walk_manager.html#maybe_give_index/3"},{"type":"function","title":"locus_mmdb_tree_walk_manager.new_counters/0","doc":"","ref":"locus_mmdb_tree_walk_manager.html#new_counters/0"},{"type":"function","title":"locus_mmdb_tree_walk_manager.new_handle/3","doc":"","ref":"locus_mmdb_tree_walk_manager.html#new_handle/3"},{"type":"function","title":"locus_mmdb_tree_walk_manager.start_link/2","doc":"","ref":"locus_mmdb_tree_walk_manager.html#start_link/2"},{"type":"function","title":"locus_mmdb_tree_walk_manager.stop/1","doc":"","ref":"locus_mmdb_tree_walk_manager.html#stop/1"},{"type":"function","title":"locus_mmdb_tree_walk_manager.take_index/1","doc":"","ref":"locus_mmdb_tree_walk_manager.html#take_index/1"},{"type":"function","title":"locus_mmdb_tree_walk_manager.terminate/2","doc":"","ref":"locus_mmdb_tree_walk_manager.html#terminate/2"},{"type":"opaque","title":"locus_mmdb_tree_walk_manager.counters/0","doc":"","ref":"locus_mmdb_tree_walk_manager.html#t:counters/0"},{"type":"opaque","title":"locus_mmdb_tree_walk_manager.handle/0","doc":"","ref":"locus_mmdb_tree_walk_manager.html#t:handle/0"},{"type":"type","title":"locus_mmdb_tree_walk_manager.reply_tag/0","doc":"","ref":"locus_mmdb_tree_walk_manager.html#t:reply_tag/0"},{"type":"type","title":"locus_mmdb_tree_walk_manager.state/0","doc":"","ref":"locus_mmdb_tree_walk_manager.html#t:state/0"},{"type":"module","title":"locus_shared_bitarray","doc":"","ref":"locus_shared_bitarray.html"},{"type":"function","title":"locus_shared_bitarray.get_positions_set_at_cell/2","doc":"","ref":"locus_shared_bitarray.html#get_positions_set_at_cell/2"},{"type":"function","title":"locus_shared_bitarray.is_set/2","doc":"","ref":"locus_shared_bitarray.html#is_set/2"},{"type":"function","title":"locus_shared_bitarray.new/1","doc":"","ref":"locus_shared_bitarray.html#new/1"},{"type":"function","title":"locus_shared_bitarray.set/2","doc":"","ref":"locus_shared_bitarray.html#set/2"},{"type":"opaque","title":"locus_shared_bitarray.t/0","doc":"","ref":"locus_shared_bitarray.html#t:t/0"},{"type":"module","title":"locus_sup","doc":"","ref":"locus_sup.html"},{"type":"function","title":"locus_sup.init/1","doc":"","ref":"locus_sup.html#init/1"},{"type":"function","title":"locus_sup.start_link/0","doc":"","ref":"locus_sup.html#start_link/0"},{"type":"module","title":"locus_util","doc":"","ref":"locus_util.html"},{"type":"function","title":"locus_util.bin_to_hex_str/1","doc":"","ref":"locus_util.html#bin_to_hex_str/1"},{"type":"function","title":"locus_util.censor_url_query/2","doc":"","ref":"locus_util.html#censor_url_query/2"},{"type":"function","title":"locus_util.expect_linked_process_termination/1","doc":"","ref":"locus_util.html#expect_linked_process_termination/1"},{"type":"function","title":"locus_util.filesystem_safe_name/1","doc":"","ref":"locus_util.html#filesystem_safe_name/1"},{"type":"function","title":"locus_util.is_date/1","doc":"","ref":"locus_util.html#is_date/1"},{"type":"function","title":"locus_util.is_termination_reason_harmless/1","doc":"","ref":"locus_util.html#is_termination_reason_harmless/1"},{"type":"function","title":"locus_util.is_unicode_string/1","doc":"","ref":"locus_util.html#is_unicode_string/1"},{"type":"function","title":"locus_util.is_utf8_binary/1","doc":"","ref":"locus_util.html#is_utf8_binary/1"},{"type":"function","title":"locus_util.lists_anymap/2","doc":"","ref":"locus_util.html#lists_anymap/2"},{"type":"function","title":"locus_util.lists_take/2","doc":"","ref":"locus_util.html#lists_take/2"},{"type":"function","title":"locus_util.parse_absolute_http_url/1","doc":"","ref":"locus_util.html#parse_absolute_http_url/1"},{"type":"function","title":"locus_util.parse_ip_address/1","doc":"","ref":"locus_util.html#parse_ip_address/1"},{"type":"function","title":"locus_util.purge_term_of_very_large_binaries/1","doc":"","ref":"locus_util.html#purge_term_of_very_large_binaries/1"},{"type":"function","title":"locus_util.resolve_http_location/2","doc":"","ref":"locus_util.html#resolve_http_location/2"},{"type":"function","title":"locus_util.url_query_encode/1","doc":"","ref":"locus_util.html#url_query_encode/1"},{"type":"module","title":"locus_waiter","doc":"","ref":"locus_waiter.html"},{"type":"function","title":"locus_waiter.start/3","doc":"","ref":"locus_waiter.html#start/3"},{"type":"extras","title":"locus","doc":"locus is library for Erlang/OTP and Elixir that allows you to pinpoint the country, city or ASN of IP addresses using MaxMind GeoIP2 and other providers . The databases will be loaded on-demand and, when retrieved from the network, cached on the filesystem and updated automatically. ⚠️ For instructions on how to upgrade to 2.x, check MIGRATION.md","ref":"readme.html"},{"type":"extras","title":"locus - Usage","doc":"1. Configure your license key Skip this step if you're not loading databases directly from MaxMind. Get a free license key from MaxMind if you haven't one already. Once logged in, you'll find the page to generate it on the left menu, under &quot;My License Key&quot;. Then clone the repository, run make shell and declare your key: application : set_env ( locus , license_key , &quot;YOUR_LICENSE_KEY&quot; ) . 2. Start the database loader ok = locus : start_loader ( country , { maxmind , &quot;GeoLite2-Country&quot; } ) . % You can also use: % * an HTTP(S) URL, % * or a local path, e.g. &quot;/usr/share/GeoIP/GeoLite2-City.mmdb&quot; % * or a {custom_fetcher, Module, Args} tuple, with Module % implementing the locus_custom_fetcher behaviour. 3. Wait for the database to load (optional) { ok , _ DatabaseVersion } = locus : await_loader ( country ) . % or `{error, Reason}&#39; 4. Look up IP addresses % &gt; locus:lookup(country, &quot;93.184.216.34&quot;). % &gt; locus:lookup(country, &quot;2606:2800:220:1:248:1893:25c8:1946&quot;). % * &#39;{ok, Entry}&#39; in case of success; % * &#39;not_found&#39; if no entry was found % * &#39;{error, _}&#39; if something bad happened { ok , \#{ &lt;&lt; &quot;continent&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;code&quot; &gt;&gt; =&gt; &lt;&lt; &quot;NA&quot; &gt;&gt; , &lt;&lt; &quot;geoname_id&quot; &gt;&gt; =&gt; 6255149 , &lt;&lt; &quot;names&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;de&quot; &gt;&gt; =&gt; &lt;&lt; &quot;Nordamerika&quot; &gt;&gt; , &lt;&lt; &quot;en&quot; &gt;&gt; =&gt; &lt;&lt; &quot;North America&quot; &gt;&gt; , &lt;&lt; &quot;es&quot; &gt;&gt; =&gt; &lt;&lt; &quot;Norteamérica&quot; / utf8 &gt;&gt; , &lt;&lt; &quot;fr&quot; &gt;&gt; =&gt; &lt;&lt; &quot;Amérique du Nord&quot; / utf8 &gt;&gt; , &lt;&lt; &quot;ja&quot; &gt;&gt; =&gt; &lt;&lt; &quot;北アメリカ&quot; / utf8 &gt;&gt; , &lt;&lt; &quot;pt-BR&quot; &gt;&gt; =&gt; &lt;&lt; &quot;América do Norte&quot; / utf8 &gt;&gt; , &lt;&lt; &quot;ru&quot; &gt;&gt; =&gt; &lt;&lt; &quot;Северная Америка&quot; / utf8 &gt;&gt; , &lt;&lt; &quot;zh-CN&quot; &gt;&gt; =&gt; &lt;&lt; &quot;北美洲&quot; / utf8 &gt;&gt; } } , &lt;&lt; &quot;country&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;geoname_id&quot; &gt;&gt; =&gt; 6252001 , &lt;&lt; &quot;iso_code&quot; &gt;&gt; =&gt; &lt;&lt; &quot;US&quot; &gt;&gt; , &lt;&lt; &quot;names&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;de&quot; &gt;&gt; =&gt; &lt;&lt; &quot;USA&quot; &gt;&gt; , &lt;&lt; &quot;en&quot; &gt;&gt; =&gt; &lt;&lt; &quot;United States&quot; &gt;&gt; , &lt;&lt; &quot;es&quot; &gt;&gt; =&gt; &lt;&lt; &quot;Estados Unidos&quot; &gt;&gt; , &lt;&lt; &quot;fr&quot; &gt;&gt; =&gt; &lt;&lt; &quot;États-Unis&quot; / utf8 &gt;&gt; , &lt;&lt; &quot;ja&quot; &gt;&gt; =&gt; &lt;&lt; &quot;アメリカ合衆国&quot; / utf8 &gt;&gt; , &lt;&lt; &quot;pt-BR&quot; &gt;&gt; =&gt; &lt;&lt; &quot;Estados Unidos&quot; &gt;&gt; , &lt;&lt; &quot;ru&quot; &gt;&gt; =&gt; &lt;&lt; &quot;США&quot; / utf8 &gt;&gt; , &lt;&lt; &quot;zh-CN&quot; &gt;&gt; =&gt; &lt;&lt; &quot;美国&quot; / utf8 &gt;&gt; } } , &lt;&lt; &quot;registered_country&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;geoname_id&quot; &gt;&gt; =&gt; 6252001 , &lt;&lt; &quot;iso_code&quot; &gt;&gt; =&gt; &lt;&lt; &quot;US&quot; &gt;&gt; , &lt;&lt; &quot;names&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;de&quot; &gt;&gt; =&gt; &lt;&lt; &quot;USA&quot; &gt;&gt; , &lt;&lt; &quot;en&quot; &gt;&gt; =&gt; &lt;&lt; &quot;United States&quot; &gt;&gt; , &lt;&lt; &quot;es&quot; &gt;&gt; =&gt; &lt;&lt; &quot;Estados Unidos&quot; &gt;&gt; , &lt;&lt; &quot;fr&quot; &gt;&gt; =&gt; &lt;&lt; &quot;États-Unis&quot; / utf8 &gt;&gt; , &lt;&lt; &quot;ja&quot; &gt;&gt; =&gt; &lt;&lt; &quot;アメリカ合衆国&quot; / utf8 &gt;&gt; , &lt;&lt; &quot;pt-BR&quot; &gt;&gt; =&gt; &lt;&lt; &quot;Estados Unidos&quot; &gt;&gt; , &lt;&lt; &quot;ru&quot; &gt;&gt; =&gt; &lt;&lt; &quot;США&quot; / utf8 &gt;&gt; , &lt;&lt; &quot;zh-CN&quot; &gt;&gt; =&gt; &lt;&lt; &quot;美国&quot; / utf8 &gt;&gt; } } } }","ref":"readme.html#usage"},{"type":"extras","title":"locus - Documentation","doc":"Supported File Formats Database Types and Loading Database Validation Remote sources: Downloading and Updating Remote sources: Caching Local sources: Loading and Updating Logging Event Subscriptions API Reference Tested Setup License Alternative Providers Alternative Libraries (Erlang) Alternative Libraries (Elixir) Supported File Formats gzip-compressed tarballs ( .tar.gz , .tgz ) plain tarballs ( .tar ) MMDB files ( .mmdb ) gzip-compressed MMDB files ( .mmdb.gz ) For tarball files, the first file to be found within it with an .mmdb extension is the one that's chosen for loading. The implementation of MaxMind DB format is complete except for the data cache container data type. Database Types and Loading The free GeoLite2 Country, City and ASN databases were all successfully tested; presumably locus can deal with any MMDB database that maps IP address prefixes to arbitrary data The databases are loaded into memory (mostly) as is; reference counted binaries are shared with the application callers using persistent_term , and the original binary search tree is used to lookup addresses. The data for each entry is decoded on the fly upon successful lookups. Database Validation Databases, local or remote, can have their compatibility validated through the locus:check/1 function after they've been loaded (see function reference .) Alternatively, they can also be checked from the command line by use of the locus CLI utility: Run make cli to build the script, named locus , which will be deployed to the current directory. Check the database: ./locus check GeoLite2-City.mmdb # Loading database from &quot;GeoLite2-City.mmdb&quot;... # Database version {{2019,11,6},{11,58,0}} successfully loaded # Checking database for flaws... # Database is wholesome. The script will exit with code 1 in case of failure, and 0 otherwise. Warnings can produce failure through the --warnings-as-errors flag. Run ./locus check --help for a description of supported options and arguments. Remote sources: Downloading and Updating The downloaded database files, when compressed, are inflated in memory For MaxMind and HTTP downloads, the last-modified response header, if present, is used to condition subsequent download attempts (using if-modified-since request headers) in order to save bandwidth The downloaded databases are cached on the filesystem in order to more quickly achieve readiness on future launches of the database loader Database download attempts are retried upon error according to an exponential backoff policy - quickly at first (every few seconds) but gradually slowing down to every 15 minutes. Successful and dismissed download attempts will be checked for update after 6 hours. Both of these behaviours can be tweaked through the error_retries and update_period loader settings (see function reference .) When downloading from a MaxMind edition or an HTTP URL, the remote certificate will be authenticated against a list of known Certification Authorities and connection negotiation will fail in case of an expired certificate, mismatched hostname, self-signed certificate or unknown certification authority. These checks can be disabled by specifying the insecure loader option. Remote sources: Caching Caching is a best effort; the system falls back to relying exclusively on the network if needed By default a caching directory named locus_erlang is created under the 'user_cache' basedir A cached database is named after either: the MaxMind database edition name (when explicitly downloading from MaxMind), or the SHA256 hash of the HTTP(S) URL, or for {custom_fetcher, Module, Args} sources, a filesystem-safe version of Module 's name concatenated with the 32-bit erlang:phash2/2 value of the opaque database source as returned by the callbacks. Modification time of the databases is retrieved from either: the last-modified response header (when present, for MaxMind and HTTP(S) sources) the modified_on metadata property for successful locus_custom_fetcher:fetch/1 and :conditionally_fetch/2` callbacks (for databases loaded with `locus_custom_fetcher ) Caching can be disabled by specifying the no_cache option when running :start_loader The cache database location can be customised by providing {database_cache_file, FilePath} option for locus_loader ( FilePath must have a &quot;.mmdb.gz&quot; extension) Local sources: Loading and Updating The loaded database files, when compressed, are inflated in memory The database modification timestamp is used to condition subsequent load attempts in order to lower I/O activity Database load attempts are retried upon error according to an exponential backoff policy - quickly at first (every few seconds) but gradually slowing down to every 30 seconds. Successful and dismissed load attempts will be checked for update after 30 seconds. Both of these behaviours can be tweaked through the error_retries and update_period loader settings (see function reference .) Logging Five logging levels are supported: debug , info , warning , error and none The chosen backend is logger if lager is either missing or it hasn't removed logger 's default handler. The default log level is error ; it can be changed in the application's env config To tweak the log level in runtime, use locus_logger:set_loglevel/1 Event Subscriptions Any number of event subscribers can be attached to a database loader by specifying the {event_subscriber, Subscriber} option when starting the database A Subscriber can be either a module implementing the locus_event_subscriber behaviour or an arbitrary pid() The format and content of reported events can be consulted in detail on the locus_event_subscriber module documentation; most key steps in the loader pipeline are reported (download started, download succeeded, download failed, caching succeeded, loading failed, etc.) API Reference The API reference can be found on HexDocs . Tested setup Erlang/OTP 22 or newer rebar3 License MIT License Copyright (c) 2017-2024 Guilherme Andrade Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. locus is an independent project and has not been authorized, sponsored, or otherwise approved by MaxMind. Alternative Providers DB-IP.com : lite databases seem to work but setting up auto-update for them is not practical, as there's no &quot;latest&quot; URL. Alternative Libraries (Erlang) egeoip : IP Geolocation module, currently supporting the MaxMind GeoLite City Database geodata2 : Application for working with MaxMind geoip2 (.mmdb) databases geoip : Returns the location of an IP address; based on the ipinfodb.com web service geolite2data : Periodically fetches the free MaxMind GeoLite2 databases ip2location-erlang : Uses IP2Location geolocation database Alternative Libraries (Elixir) asn : IP-to-AS-to-ASname lookup freegeoip : Simple wrapper for freegeoip.net HTTP API freegeoipx : API Client for freegeoip.net geoip : Lookup the geo location for a given IP address, hostname or Plug.Conn instance geolix : MaxMind GeoIP2 database reader/decoder plug_geoip2 : Adds geo location to a Plug connection based upon the client IP address by using MaxMind's GeoIP2 database tz_world : Resolve timezones rom a location efficiently using PostGIS and Ecto","ref":"readme.html#documentation"},{"type":"extras","title":"Changelog","doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog and this project adheres to Semantic Versioning .","ref":"changelog.html"},{"type":"extras","title":"Changelog - [2.3.7] - 2024-03-16","doc":"Added OTP 25.3 to CI OTP 26.0 to CI OTP 26.1 to CI OTP 26.2 to CI Changed README CI to use latest rebar3 version that's compatible with each covered OTP release","ref":"changelog.html#2-3-7-2024-03-16"},{"type":"extras","title":"Changelog - [2.3.6] - 2022-09-20","doc":"Fixed failed load of .tgz database when its mime type is listed as &quot;application/x-tar&quot;","ref":"changelog.html#2-3-6-2022-09-20"},{"type":"extras","title":"Changelog - [2.3.5] - 2022-09-20","doc":"Fixed broken CLI check when loading database from a HTTP(S) URL","ref":"changelog.html#2-3-5-2022-09-20"},{"type":"extras","title":"Changelog - [2.3.4] - 2022-09-12","doc":"Fixed broken compilation under Elixir's Mix (introduced in 2.3.3)","ref":"changelog.html#2-3-4-2022-09-12"},{"type":"extras","title":"Changelog - [2.3.3] - 2022-09-12","doc":"Fixed unwarranted compilation warning on OTP 25","ref":"changelog.html#2-3-3-2022-09-12"},{"type":"extras","title":"Changelog - [2.3.2] - 2022-08-07","doc":"Added OTP 25 to CI Fixed a few wrong specs rebar3_lint warnings on OTP 25 rebar3_hank warnings on OTP 25 Dialyzer warnings on OTP 25 a few eqWAlizer warnings","ref":"changelog.html#2-3-2-2022-08-07"},{"type":"extras","title":"Changelog - [2.3.1] - 2022-04-19","doc":"Fixed spelling mistakes in CHANGELOG [Kian-Meng Ang]","ref":"changelog.html#2-3-1-2022-04-19"},{"type":"extras","title":"Changelog - [2.3.0] - 2022-01-25","doc":"Added the ability to customize database cache path [Bartosz Szafran]","ref":"changelog.html#2-3-0-2022-01-25"},{"type":"extras","title":"Changelog - [2.2.2] - 2021-12-01","doc":"Fixed wrong reference to custom database fetcher in README [Bartosz Szafran]","ref":"changelog.html#2-2-2-2021-12-01"},{"type":"extras","title":"Changelog - [2.2.1] - 2021-09-22","doc":"Fixed decoding of negative integers [made wrong in 2.0.0]","ref":"changelog.html#2-2-1-2021-09-22"},{"type":"extras","title":"Changelog - [2.2.0] - 2021-09-03","doc":"Changed documentation from edoc to ExDoc imported version of tls_certificate_check to '~&gt; 1.9'","ref":"changelog.html#2-2-0-2021-09-03"},{"type":"extras","title":"Changelog - [2.1.0] - 2021-08-30","doc":"Added locus_mmdb:unpack_tree_data_and_data_section/2 to the API locus_mmdb_data_codec:parse_on_index/3 to the API CI on Windows Removed no longer warranted run time dependency ( public_key ) Fixed wrong return of errors during :check/1 for maps containing maps or arrays which had been checked previously wrong paths in :check/1 errors or warnings concerning maps no longer warranted type definition","ref":"changelog.html#2-1-0-2021-08-30"},{"type":"extras","title":"Changelog - [2.0.0] - 2021-08-30","doc":"Added support for retrieving databases using consumer-defined locus_custom_fetcher s support for decoding IEEE-754 infinities in MMDB data locus:check/1 to API (which replaces locus:analyze/1 and can be up to 3200% faster 🏎️) details to MMDB unpacking errors linting checks with rebar3_lint dead code checks with rebar3_hank Changed ⚠️ return type of locus:lookup/2 (see MIGRATION.md) database loader to use persistent_term instead of ETS MMDB decoder to perform stricter metadata validations MMDB decoder to not crash upon maps containing duplicate keys databases downloaded through HTTP(S) without a last-modified response header to no longer be cached imported version of tls_certificate_check to '~&gt; 1.7' single CT suite covering both filesystem and HTTP sources into one for each test coverage for the better Removed ⚠️ locus:wait_for_loader/1 from API (deprecated in 1.10.0 - see MIGRATION.md) ⚠️ locus:wait_for_loader/2 from API (deprecated in 1.10.0 - see MIGRATION.md) ⚠️ locus:wait_for_loaders/2 from API (deprecated in 1.10.0 - see MIGRATION.md) ⚠️ locus:get_version/1 from API (deprecated in 1.4.0 - see MIGRATION.md) ⚠️ locus:analyze/1 from API ( locus:check/1 now fulfills this role - see MIGRATION.md) deprecated loader options pre_readiness_update_period and post_readiness_update_period (see MIGRATION.md) warnings on the use of discontinued GeoLite2 HTTP URLs","ref":"changelog.html#2-0-0-2021-08-30"},{"type":"extras","title":"Changelog - [1.16.1] - 2021-07-12","doc":"Fixed erroneous decoding of 32-bit signed integers as signed when they're less than 4 bytes in length small risk of API functions :await_loader and :await_loaders blocking indefinitely longer than they should","ref":"changelog.html#1-16-1-2021-07-12"},{"type":"extras","title":"Changelog - [1.16.0] - 2021-05-13","doc":"Added OTP 24 to CI targets Changed minimum Erlang/OTP version to 22 imported version of tls_certificate_check to '~&gt; 1.5'","ref":"changelog.html#1-16-0-2021-05-13"},{"type":"extras","title":"Changelog - [1.15.0] - 2021-04-02","doc":"Changed imported version of tls_certificate_check to '~&gt; 1.3' minimum Erlang/OTP version to 21.2 Removed stacktrace_compat dependency (now-)dead code that dealt with pre- OTP 21.2 differences in stdlib and such unmaintained compatibility with rebar 2 Fixed import of MaxMind test data in a way that works both locally and on GHA","ref":"changelog.html#1-15-0-2021-04-02"},{"type":"extras","title":"Changelog - [1.14.1] - 2021-03-16","doc":"Fixed Hex documentation","ref":"changelog.html#1-14-1-2021-03-16"},{"type":"extras","title":"Changelog - [1.14.0] - 2021-03-12","doc":"Changed imported version of tls_certificate_check to 1.2.0 Fixed broken tls_certificate_check s when using rebar3 3.14.4","ref":"changelog.html#1-14-0-2021-03-12"},{"type":"extras","title":"Changelog - [1.13.2] - 2020-12-10","doc":"Changed CI from Travis to GitHub actions Fixed documentation unavailability in hexdocs.pm (hopefully)","ref":"changelog.html#1-13-2-2020-12-10"},{"type":"extras","title":"Changelog - [1.13.1] - 2020-12-08","doc":"Fixed tls_certificate_check compilation errors on OTP 20.1+, when on top of macOS Big Sur","ref":"changelog.html#1-13-1-2020-12-08"},{"type":"extras","title":"Changelog - [1.13.0] - 2020-12-05","doc":"Changed CA bundles, based on the latest mkcert.org full CA list as of Nov 13, 2020 imported stacktrace_compat version to benefit from its latest improvements","ref":"changelog.html#1-13-0-2020-12-05"},{"type":"extras","title":"Changelog - [1.12.2] - 2020-10-29","doc":"Fixed erroneous execution of the optional &quot;remote HTTP&quot; test group when a license key is lacking","ref":"changelog.html#1-12-2-2020-10-29"},{"type":"extras","title":"Changelog - [1.12.1] - 2020-10-16","doc":"Fixed misdetection of Mix as being rebar 2 and the erroneous compilation warnings that followed it","ref":"changelog.html#1-12-1-2020-10-16"},{"type":"extras","title":"Changelog - [1.12.0] - 2020-05-21","doc":"Added support for OTP 23 Changed checksum verification algorithm of MaxMind downloads from MD5 to SHA-256","ref":"changelog.html#1-12-0-2020-05-21"},{"type":"extras","title":"Changelog - [1.11.0] - 2020-05-11","doc":"Added support for HTTPS redirections across distinct hostnames support for not censoring license keys from MaxMind URLs mentioned in logs support for censorship of arbitrary query arguments from HTTP URLs mentioned in logs truncation of large HTTP URLs mentioned in logs download_redirected events to HTTP downloads too_many_redirections and invalid_redirection reasons to HTTP download failures mention of compatibility with other providers Changed consumer-subscribed events as to follow the same URL censorship rules as the built-in logger documented MaxMind database edition format from atoms to tuples while keeping retrocompatibility","ref":"changelog.html#1-11-0-2020-05-11"},{"type":"extras","title":"Changelog - [1.10.2] - 2020-03-13","doc":"Added unmaintained compatibility with rebar 2","ref":"changelog.html#1-10-2-2020-03-13"},{"type":"extras","title":"Changelog - [1.10.1] - 2020-03-11","doc":"Changed CA bundles, based on the latest Mozilla Included CA Certificate List [Paulo Oliveira] Fixed misformatted log warning use of deprecated function in README example of how to use the library display of private function in generated function reference","ref":"changelog.html#1-10-1-2020-03-11"},{"type":"extras","title":"Changelog - [1.10.0] - 2020-02-12","doc":"Added :await_loader API function which, contrary to :wait_for_loader , will await readiness up to the entire specified interval (rather than return upon the first encountered failure) checksum verification of databases downloaded directly from MaxMind rejection of successful HTTP downloads if body size doesn't match content-length censorship of license key from database URLs mentioned in logs purging of very large binaries from internally caught exceptions which are known error cases, as to lower the risk of the VM getting OOM-killed when logging formatters get their hands on those very large chunks of data Changed default behaviour upon failing to load a database, as to retry loading while exponentially backing off (using very short intervals at first) Deprecated :wait_for_loader and :wait_for_loaders API functions (use :await_loader and :await_loaders instead) Fixed incomplete spec for locus_loader:event() type wrong spec for locus_maxmind_download:msg() and locus_maxmind_download:event() types","ref":"changelog.html#1-10-0-2020-02-12"},{"type":"extras","title":"Changelog - [1.9.0] - 2020-02-03","doc":"Changed documentation as to reflect the recent changes to MaxMind licensing requirements","ref":"changelog.html#1-9-0-2020-02-03"},{"type":"extras","title":"Changelog - [1.9.0-beta] - 2020-01-02","doc":"Added support for loading databases with full awareness of license keys (now mandatory) Deprecated the use of discontinued &quot; https://geolite.maxmind.com/download/geoip/database/GeoLite2-...&quot; database URLs","ref":"changelog.html#1-9-0-beta-2020-01-02"},{"type":"extras","title":"Changelog - [1.8.0] - 2019-11-05","doc":"Added support for returning types other than map upon successful lookups Changed MMDB decoder, which was split into separate tree, data section and analysis modules imported stacktrace_compat version [1.0.2 =&gt; 1.1.1] Removed support for OTP 18 Fixed incidents of locus managerial processes keeping references to old binaries, upon a database update, for a potentially unlimited time (OTP 20+ only) broken logging of playground shell on OTP 21.1+","ref":"changelog.html#1-8-0-2019-11-05"},{"type":"extras","title":"Changelog - [1.7.0] - 2019-08-12","doc":"Added ability of loading databases from uncompressed tarballs ( .tar files) ability of loading unpacked databases ( .mmdb and .mmdb.gz files) stacktrace of caught exceptions to event reporting (including custom logger) ability of launching database loaders under library consumers' own supervisors wait_for_loaders/2 API method for concurrently awaiting multiple database loaders Changed log level of HTTP and filesystem database loading failures from warning to error HTTP and filesystem loaders into a common loader codebase caching of HTTP databases as to store and load compressed .mmdb files rather than tarballs supervision structure as to launch database loaders as transient processes under a new simple_one_for_one supervisor dependency versions: certifi [2.4.2 =&gt; 2.5.1] ssl_verify_fun [1.1.4 =&gt; 1.1.5] Removed support for OTP 17.4 and 17.5 undocumented support for rebar 2 half-baked and unwarranted support for file:// -prefixed URLs Fixed case-sensitive patterning of .mmdb file extensions within tarballs overly verbose logger messages on OTP 21.1+ HTTPS certificate validation test cases on OTP 22","ref":"changelog.html#1-7-0-2019-08-12"},{"type":"extras","title":"Changelog - [1.6.2] - 2019-03-16","doc":"Fixed Dialyzer warning on OTP 21.3","ref":"changelog.html#1-6-2-2019-03-16"},{"type":"extras","title":"Changelog - [1.6.1] - 2019-02-04","doc":"Fixed crash in HTTP loader when database URL scheme is not in lower case (introduced in 1.6.0)","ref":"changelog.html#1-6-1-2019-02-04"},{"type":"extras","title":"Changelog - [1.6.0] - 2019-01-27","doc":"Added new API method for validating loaded databases ( locus:analyze/1 ) new command line tool supporting database validation new dependencies: certifi 2.4.2 ssl_verify_fun 1.1.4 stacktrace_transform 1.0.2 Changed test coverage using MaxMind's test data was greatly extended database decoder was thoroughly optimized documentation was mildly improved Fixed misguided rejection of UTF-8 strings with non-printable (but valid) codepoints unnecessarily strict refusal to load 2.x database formats succeeding 2.0 Security safety of database HTTPS downloads was substantially improved by now rejecting expired certificates, mismatched hostnames, self-signed certificates or unknown certificate authorities infinite recursion in maliciously crafted databases due to circular paths is now prevented","ref":"changelog.html#1-6-0-2019-01-27"},{"type":"extras","title":"Changelog - [1.5.1] - 2019-01-19","doc":"Fixed unwarranted import of rebar3_hex plugin in library consumers","ref":"changelog.html#1-5-1-2019-01-19"},{"type":"extras","title":"Changelog - [1.5.0] - 2018-11-25","doc":"Added ability of tweaking pre- and post-readiness database update periods test coverage of HTTP-loaded database updates Fixed undeterministic test cases which sometimes broke","ref":"changelog.html#1-5-0-2018-11-25"},{"type":"extras","title":"Changelog - [1.4.0] - 2018-06-20","doc":"Added official test cases for good data at https://github.com/maxmind/MaxMind-DB/ Changed string and binary IP address parsing to handle ranges and shortened addresses Deprecated :get_version/1 (use :get_info/2)","ref":"changelog.html#1-4-0-2018-06-20"},{"type":"extras","title":"Changelog - [1.3.1] - 2018-05-04","doc":"Fixed incompatibility with OTP 20.3.1 due to gen_statem bug (issue with init actions)","ref":"changelog.html#1-3-1-2018-05-04"},{"type":"extras","title":"Changelog - [1.2.3] - 2018-05-04","doc":"Fixed incompatibility with OTP 20.3.1 due to gen_statem bug (issue with init actions)","ref":"changelog.html#1-2-3-2018-05-04"},{"type":"extras","title":"Changelog - [1.1.5] - 2018-05-04","doc":"Fixed incompatibility with OTP 20.3.1 due to gen_statem bug (issue with init actions)","ref":"changelog.html#1-1-5-2018-05-04"},{"type":"extras","title":"Changelog - [1.0.2] - 2018-05-04","doc":"Fixed incompatibility with OTP 20.3.1 due to gen_statem bug (issue with init actions)","ref":"changelog.html#1-0-2-2018-05-04"},{"type":"extras","title":"Changelog - [1.3.0] - 2018-03-28","doc":"Added ability of loading databases from local file system type spec of database entries Fixed wrong handling of timezones on cached tarballs wrong handling of daylight saving time on conditional HTTP requests","ref":"changelog.html#1-3-0-2018-03-28"},{"type":"extras","title":"Changelog - [1.2.2] - 2018-03-28","doc":"Fixed wrong handling of timezones on cached tarballs wrong handling of daylight saving time on conditional HTTP requests","ref":"changelog.html#1-2-2-2018-03-28"},{"type":"extras","title":"Changelog - [1.1.4] - 2018-03-28","doc":"Fixed wrong handling of timezones on cached tarballs wrong handling of daylight saving time on conditional HTTP requests","ref":"changelog.html#1-1-4-2018-03-28"},{"type":"extras","title":"Changelog - [1.0.1] - 2018-03-28","doc":"Fixed wrong handling of timezones on cached tarballs wrong handling of daylight saving time on conditional HTTP requests","ref":"changelog.html#1-0-1-2018-03-28"},{"type":"extras","title":"Changelog - [1.2.1] - 2018-02-15","doc":"Fixed undesirable inlining","ref":"changelog.html#1-2-1-2018-02-15"},{"type":"extras","title":"Changelog - [1.2.0] - 2018-02-15","doc":"Added OTP 17.4 and 17.5 support","ref":"changelog.html#1-2-0-2018-02-15"},{"type":"extras","title":"Changelog - [1.1.3] - 2018-02-13","doc":"Fixed matched IP address prefix not being returned on successful lookups","ref":"changelog.html#1-1-3-2018-02-13"},{"type":"extras","title":"Changelog - [1.1.2] - 2018-02-13","doc":"Fixed documentation external links not opening in parent frame","ref":"changelog.html#1-1-2-2018-02-13"},{"type":"extras","title":"Changelog - [1.1.1] - 2018-02-12","doc":"Fixed internal functions showing up as public in documentation documented description of locus_logger:set_loglevel/2","ref":"changelog.html#1-1-1-2018-02-12"},{"type":"extras","title":"Changelog - [1.1.0] - 2018-02-11","doc":"Added OTP 18 support OTP 19.0, 19.1 and 19.2 support ability of consulting database metadata, source and version through :get_info ability of subscribing database loader events ability of specifying connect, download start and idle download timeouts ability of turning off cache","ref":"changelog.html#1-1-0-2018-02-11"},{"type":"extras","title":"Changelog - [1.0.0] - 2017-12-31","doc":"Added ability of downloading .mmdb databases using HTTP ability of querying those databases ability of caching said databases on the local filesystem ability of conditioning said downloads based on cache content and 'if-modified-since' headers ability of regularly performing database update attempts OTP 19.3 and 20.x for all of the above","ref":"changelog.html#1-0-0-2017-12-31"},{"type":"extras","title":"Migration guide","doc":"Whenever there's an interface breaking change (a change in the project's major version), required migration instructions will be detailed in this file.","ref":"migration.html"},{"type":"extras","title":"Migration guide - From [1.x] to [2.x]","doc":"Update any code matching the return of locus:lookup/2 to match not_found rather than {error, not_found} : % before: case locus : lookup ( country , &quot;93.184.216.34&quot; ) of { ok , \#{ &lt;&lt; &quot;country&quot; &gt;&gt; := \#{ &lt;&lt; &quot;iso_code&quot; &gt;&gt; := Country } } } -&gt; % [...] { error , not_found } -&gt; % [...] end . % after: case locus : lookup ( country , &quot;93.184.216.34&quot; ) of { ok , \#{ &lt;&lt; &quot;country&quot; &gt;&gt; := \#{ &lt;&lt; &quot;iso_code&quot; &gt;&gt; := Country } } } -&gt; % [...] not_found -&gt; % [...] end . calls to wait_for_loader/1 to invoke await_loader/1 instead: % before case locus : wait_for_loader ( country ) of { ok , _ LoadedVersion } -&gt; % [...] { error , { loading , LoadAttemptFailure } } -&gt; % [...] end . % after case locus : await_loader ( country ) of { ok , _ LoadedVersion } -&gt; % [...] { error , { timeout , LoadAttemptFailures } } -&gt; % Notice how `LoadAttemptFailures&#39; is a list % [...] end . calls to wait_for_loader/2 to invoke await_loader/2 instead: % before case locus : wait_for_loader ( country , _ Timeout = 30000 ) of { ok , _ LoadedVersion } -&gt; % [...] { error , { loading , LoadAttemptFailure } } -&gt; % [...] { error , timeout } -&gt; % [...] end . % after case locus : await_loader ( country , _ Timeout = 30000 ) of { ok , _ LoadedVersion } -&gt; % [...] { error , { timeout , LoadAttemptFailures } } -&gt; % Notice how `LoadAttemptFailures&#39; is a list % and there&#39;s no longer a separate return type for `timeout` % [...] end . calls to wait_for_loaders/2 to invoke await_loaders/2 instead: % before case locus : wait_for_loaders ( [ country , asn ] , _ Timeout = 30000 ) of { ok , _ LoadedVersionPerDatabase } -&gt; % [...] { error , { DatabaseId , LoaderFailure } } -&gt; % [...] { error , timeout } -&gt; % [...] end . % after case locus : await_loaders ( [ country , asn ] , _ Timeout = 30000 ) of { ok , _ LoadedVersionPerDatabase } -&gt; % [...] { error , ErrorPerDatabase , PartialSuccesses } -&gt; % Notice how `ErrorPerDatabase&#39; and `PartialSuccesses&#39; are maps % and there&#39;s no longer a separate return type for `timeout` % [...] end . calls to get_version/1 to invoke get_info/2 instead: % before { ok , LoadedVersion } = locus : get_version ( country ) , % after { ok , LoadedVersion } = locus : get_info ( country , version ) , any use of the {pre_readiness_update_period, Interval} loader option, if exponential backoff (the default for some time) is not to your liking: % before { pre_readiness_update_period , Interval } % after { error_retries , { backoff , Interval } } any use of the {post_readiness_update_period, Interval} loader option: % before { post_readiness_update_period , Interval } % after { update_period , Interval } any code matching/using metadata , whether through locus:get_info/1 or locus:get_info/2 , to use atom keys instead of binary ones: % before: { ok , Metadata } = locus : get_info ( country , metadata ) , \#{ &lt;&lt; &quot;binary_format_major_version&quot; &gt;&gt; := Major , &lt;&lt; &quot;binary_format_minor_version&quot; &gt;&gt; := Minor , &lt;&lt; &quot;node_count&quot; &gt;&gt; := _ , &lt;&lt; &quot;record_size&quot; &gt;&gt; := _ , &lt;&lt; &quot;ip_version&quot; &gt;&gt; := _ , &lt;&lt; &quot;database_type&quot; &gt;&gt; := _ , &lt;&lt; &quot;languages&quot; &gt;&gt; := _ , &lt;&lt; &quot;build_epoch&quot; &gt;&gt; := _ , &lt;&lt; &quot;description&quot; &gt;&gt; := _ } = Metadata , % after: { ok , Metadata } = locus : get_info ( country , metadata ) , \#{ binary_format_version := { Major , Minor } , % Notice how this was two keys before node_count := _ , record_size := _ , ip_version := _ , database_type := _ , languages := _ , build_epoch := _ , description := _ } = Metadata , any code calling and matching the return of locus:analyze/1 with one to locus:check/1 (the semantics of the return type are wildly different; consult the API reference for details) Remove your code matching or making use of prefix for a successful locus:lookup/2 , e.g. % `prefix&#39; is gone (open an issue if you&#39;d like to see it back) { ok , \#{ prefix := _ } } = locus : lookup ( country , &quot;94.186.216.34&quot; )","ref":"migration.html#from-1-x-to-2-x"},{"type":"extras","title":"LICENSE","doc":"MIT License Copyright (c) 2017-2024 Guilherme Andrade Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}]